package com.yc.ship.module.trade.service.billrule;


import com.yc.ship.framework.common.pojo.PageResult;
import com.yc.ship.module.ota.dal.dataobject.distributor.DistributorDO;
import com.yc.ship.module.trade.controller.admin.billrule.vo.BillRulePageReqVO;
import com.yc.ship.module.trade.controller.admin.billrule.vo.BillRuleRespVO;
import com.yc.ship.module.trade.controller.admin.billrule.vo.BillRuleSaveReqVO;
import com.yc.ship.module.trade.api.dto.StoreRespVO;
import com.yc.ship.module.trade.dal.dataobject.billdistributor.BillDistributorDO;
import com.yc.ship.module.trade.dal.dataobject.billrule.BillRuleDO;

import javax.validation.Valid;
import java.util.List;

/**
 * 旅行社账单规则 Service 接口
 *
 * @author 管理员
 */
public interface BillRuleService {

    /**
     * 创建旅行社账单规则
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createBillRule(@Valid BillRuleSaveReqVO createReqVO);

    /**
     * 更新旅行社账单规则
     *
     * @param updateReqVO 更新信息
     */
    void updateBillRule(@Valid BillRuleSaveReqVO updateReqVO);

    /**
     * 删除旅行社账单规则
     *
     * @param id 编号
     */
    void deleteBillRule(Long id);

    /**
     * 获得旅行社账单规则
     *
     * @param id 编号
     * @return 旅行社账单规则
     */
    BillRuleRespVO getBillRule(Long id);

    /**
     * 获得旅行社账单规则分页
     *
     * @param pageReqVO 分页查询
     * @return 旅行社账单规则分页
     */
    PageResult<BillRuleDO> getBillRulePage(BillRulePageReqVO pageReqVO);

    List<DistributorDO> selectDistributorList(String ids);
    List<DistributorDO> getDistributorList();
    List<StoreRespVO> selectStoreList(Long distributorId);
    List<BillRuleDO> getBillRuleList();

    List<BillDistributorDO> getDistributorList(Long id);

}